//+------------------------------------------------------------------+
//|                                                 EMA_BarCount_2.mq5 |
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots   2
//---      MovingAverages.mqh
#include <emaBarCount.mqh>
//---- plot 
#property indicator_label1  "EMA_BarCount_2"
#property indicator_type1   DRAW_LINE
#property indicator_color1  Blue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
#property indicator_type2   DRAW_LINE
#property indicator_color2  Black
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- input parameters
input int      barCount =15;
input int      period_1   = 5;
input int      period_2  = 10;

//--- indicator buffers
double         ema_1[],
               ema_2[]  ;
int i, start;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  { // 1
//--- indicator buffers mapping
   SetIndexBuffer(0,ema_1,INDICATOR_DATA);
   SetIndexBuffer(1,ema_2,INDICATOR_DATA);
   string shortname;
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,shortname);
   PlotIndexSetString(1,PLOT_LABEL,shortname);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,5);
//---
   return(0);
  } // 1
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,    //   price[];
   const int prev_calculated,//      ;
   const int begin,//      price[]   ;
   const double &price[]) // ,      ;
  { //2
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN, rates_total - barCount -  1);  
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN, rates_total - barCount -  1);  
//---    price[]      
   if(period_1 <=1 || begin + period_1 + period_2 + barCount > rates_total) return(0);    
//---     
 emaBarCount(rates_total,prev_calculated,
       begin + period_2,//          
       barCount, // -       period
       period_1,      //   
       price,       //    
       ema_1);  //               

emaBarCount(rates_total,prev_calculated,
       begin,    //          
       barCount,         // -       period
       period_2,      //   
       ema_1,       //    
       ema_2);  //          
       
       
if(prev_calculated==0) //  
   { // 3
// ------      - ---------------------      
    start = rates_total - barCount - period_1 - period_2 - begin;    
 Print("    1#  start = rates_total - barCount - period_1 - period_2 - begin; ");  
 Print("    2# start= ",start,", rates_total= ",rates_total,", barCount= ",barCount,", period_1= ",period_1,", period_2= ",period_2);    
 Print("3#   i= 0,  = ",  -rates_total +1  );  
 Print("              .  .  .   ");
          for(i= 0;  i< rates_total;  i++)  
          if(  ema_1[i]>0)
  Print("4# i= ",i,", = ",i+1-rates_total,", price= ",price[i],", ema_1= ",ema_1[i],", ema_2= ",ema_2[i]); 
   Print("  ");
   } // 3
   else 
  { // 4
  start= prev_calculated-1; 
   for   (i=start;  i<rates_total;i++)
   if(  ema_1[i]>0)
  Print("   5# i= ",i,", = ",i+1-rates_total,", price= ",price[i],", ema_1= ",ema_1[i]); 
   } // 4 
// -- return value of prev_calculated for next call    
   return(rates_total);
  } // 2      =====   ,    = ! :) ================ +
